#include <stdio.h>
#include <windows.h>
#include <winnt.h>
#include <Imagehlp.h>

int LoadPeHeader (char* File, IMAGE_NT_HEADERS32* NtHdr) {
	DWORD N;
	IMAGE_DOS_HEADER DosHdr;
	HANDLE hFile = CreateFile (File, GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0,0);
	if (hFile > 0) {
		ReadFile (hFile, &DosHdr, sizeof(DosHdr), &N, 0);
		SetFilePointer (hFile, DosHdr.e_lfanew, 0, FILE_BEGIN);
		ReadFile (hFile, NtHdr, sizeof(IMAGE_NT_HEADERS32), &N, 0);
		CloseHandle (hFile);
	}
	return 0;
}

int SavePeHeader (char* File, IMAGE_NT_HEADERS32* NtHdr) {
	DWORD N;
	IMAGE_DOS_HEADER DosHdr;
	HANDLE hFile = CreateFile (File, GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0,0);
	if (hFile > 0) {
		ReadFile (hFile, &DosHdr, sizeof(DosHdr), &N, 0);
		SetFilePointer (hFile, DosHdr.e_lfanew, 0, FILE_BEGIN);
		WriteFile (hFile, NtHdr, sizeof(IMAGE_NT_HEADERS32), &N, 0);
		CloseHandle (hFile);
	}
	return 0;
}

int main (int argc, char* argv[]) {
	DWORD OldSum = 0, NewSum = 0;
	IMAGE_NT_HEADERS32 NtHdr;
	if (argc == 1) {
		printf("Usage: resum.exe <dll or exe file>\n");
		printf("Updates exe/dll checksum.\n");
		printf("Author: Benjamin Kalytta (ICQ UIN: 41161163)\n");
		return -1;
	}
	if (MapFileAndCheckSum(argv[1], &OldSum, &NewSum) == CHECKSUM_SUCCESS) {
		printf("Update Checksum for \"%s\", change from %.8x to %.8x\n", argv[1], OldSum, NewSum);
		LoadPeHeader(argv[1], &NtHdr);
		NtHdr.OptionalHeader.CheckSum = NewSum;
		SavePeHeader(argv[1], &NtHdr);
	} else {
		printf("Can't map \"%s\"", argv[1]);
	}
}